﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace PresetVertexToTrackedPolygon
{
    class PresetVertexTrackInteractiveOverlay : TrackInteractiveOverlay
    {
        private PointShape presetPointShape = null;
        public PointShape PresetPointShape
        {
            get { return presetPointShape; }
            set { presetPointShape = value; }
        }

        protected override void OnTrackEnded(TrackEndedTrackInteractiveOverlayEventArgs e)
        {
            addVertexIndex = 0;
            presetPointShape = null;
            base.OnTrackEnded(e);
        }

        private int addVertexIndex = 0;
        protected override BaseShape GetTrackingShapeCore()
        {
            BaseShape baseShape = base.GetTrackingShapeCore();
            if (baseShape is PolygonShape)
            {
                PolygonShape polygon = (PolygonShape)baseShape;
                if (polygon != null && presetPointShape != null)
                {
                    //It adds the preset point after the mouse move point. How to have the preset point added BEFORE the mouse move point?
                    if (addVertexIndex == 0)
                    { addVertexIndex = Vertices.Count - 2; }

                    Vertices[addVertexIndex] = new Vertex(presetPointShape);
                    System.Diagnostics.Debug.WriteLine(Vertices.Count.ToString());
                }
            }
            return baseShape;
        }

        protected override InteractiveResult MouseClickCore(InteractionArguments interactionArguments)
        {
            if (interactionArguments.MouseButton == MapMouseButton.Left)
            {
                return base.MouseClickCore(interactionArguments);
            }
            else
            {
                return new InteractiveResult();
            }
        }
    }
}
